/**
 * @file snow_effect.h
 */

#ifndef _SNOW_EFFECT
#define _SNOW_EFFECT

#include "vector.h"
#include "particle_system.h"
#include "material.h"
#include "vector2D.h"

#include "weather_effect.h"

class SpriteParticles;

class SnowEffect : public WeatherEffect
{
  public:
    SnowEffect(const TiXmlElement* root = NULL);
    virtual ~SnowEffect();

    virtual void loadParams(const TiXmlElement* root);

    virtual bool init();

    virtual bool activate();
    virtual bool deactivate();

    virtual void draw() const;
    virtual void tick(float dt);

//     inline void setSnowMode(const std::string& mode) { this->snowMode = this->stringToSnowMode(mode); }
//     inline void setSnowDensity(float density) { this->snowDensity = density; }
//     inline void setSnowRange(float start, float end) { this->snowStart = start; this->snowEnd = end; }
//     inline void setSnowColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
  private:
//     GLint                    snowMode;
//     GLfloat                 snowDensity;
//     GLfloat                 snowStart;
//     GLfloat                 snowEnd;
//     Vector                  colorVector;
    static SpriteParticles* snowParticles;
    
    ParticleEmitter*          emitter;
};


#endif  /* _SNOW_EFFECT */
